try:
    from setuptools import setup, find_packages
except ImportError:
    from ez_setup import use_setuptools
    use_setuptools()
    from setuptools import setup, find_packages

VERSION = open('VERSION').read().strip()

setup(
    name='sloecode',
    version=VERSION,
    description='Sloecode code forge: server component.',
    long_description=open('README').read(),
    author='Sloecode Developers',
    author_email='sloecode-dev@lists.launchpad.net',
    url='http://launchpad.net/sloecode/',
    license = 'GNU Affero General Public License v3',
    install_requires=[
        "Pylons>=0.10",
        "SQLAlchemy>=0.6",
        "Jinja2",
        "repoze.who<=1.99",
        "repoze.what",
        "repoze.who.plugins.sa",
        "repoze.what-pylons",
        "pycrypto",  #for smartserver
        "pyasn1",
        "zope.component",
    ],
    packages=find_packages(exclude=['ez_setup']),
    include_package_data=True,
    test_suite='nose.collector',
    zip_safe=False,
    entry_points="""
    [paste.app_factory]
    main = sloecode.config.middleware:make_app

    [paste.app_install]
    main = pylons.util:PylonsInstaller
    """,
    classifiers = ['Development Status :: 4 - Beta',
                   'Intended Audience :: Developers',
                   'Intended Audience :: Education',
                   'Programming Language :: Python',
                   'Programming Language :: Python :: 2',
                   'Programming Language :: Python :: 2.6',
                   'Programming Language :: Python :: 2.7',
                   'License :: OSI Approved :: GNU Affero General Public License v3',
                   'Environment :: Web Environment',
                   'Topic :: Internet',
                   'Topic :: Internet :: WWW/HTTP',
                   'Topic :: Software Development',
                   'Topic :: Software Development :: Version Control',
                   'Topic :: System :: Software Distribution',
                   ],
)
