"""Person/Project Membership model.
"""

from sqlalchemy import Column
from sqlalchemy.schema import ForeignKey
from sqlalchemy.orm import relationship
from sqlalchemy.types import Integer, Enum

from sloecode.model.meta import Base, QueryMixin

PR_OBSERVER = 'Observer'
PR_DEVELOPER = 'Developer'
PR_MANAGER = 'Manager'
PROJECT_ROLES = (PR_OBSERVER, PR_DEVELOPER, PR_MANAGER)

class Membership(Base, QueryMixin):
    "A model that holds membership informaton between people and projects."

    __tablename__ = "person_project_membership"

    id = Column(Integer, primary_key=True)

    person_id = Column(ForeignKey('person.id'))
    project_id = Column(ForeignKey('project.id'))
    role = Column(Enum(*PROJECT_ROLES))


