# Should really work out how to have multiple copyrights...
# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

"""Glues the codehosting SSH daemon together."""

__metaclass__ = type
__all__ = [
    'make_portal',
    ]

from twisted.conch.interfaces import ISession
from twisted.cred.portal import (
    IRealm,
    Portal,
    )
from twisted.python import components
from zope.interface import implements

from sloecode.sshserver.auth import (
    PublicKeyChecker,
    SloecodeAvatar,
    )
from sloecode.sshserver.launcher import SmartServerLauncher

# TODO: change the way that this works so the avatar we create also implements
# ISession.
session_factory = SmartServerLauncher('bzr', 'cool_hostname')
components.registerAdapter(session_factory, SloecodeAvatar, ISession)


class SloecodeRealm:
    """A very simple realm that creates our avatars."""

    implements(IRealm)

    def __init__(self):
        pass

    def requestAvatar(self, avatar_id, mind, *interfaces):
        # Not sure if we need a deferred here or not...
        avatar = SloecodeAvatar(avatar_id)
        return interfaces[0], avatar, avatar.logout


def make_portal():
    """Create and return a `Portal` for the SSH service.

    This portal accepts SSH credentials and returns our customized SSH
    avatars (see `CodehostingAvatar`).
    """
    portal = Portal(SloecodeRealm())
    portal.registerChecker(PublicKeyChecker())
    return portal
